// This is a part of the Tixi.Com Mossad project
// Copyright (C) 2007 Tixi.Com GmbH
// All rights reserved

////////////////////////////////////////////////////////////////////////////////
// iostream/RemovFile.cpp
//
// Created: 15.03.2007 HD
////////////////////////////////////////////////////////////////////////////////

#include "diskio.h"
#include "ff.h"
#include "mmc.h"

#define CHECK_MOUNTED	if(NULL != m_FileObject.fs){ if( !sm_bIsMounted[m_FileObject.fs->drive] ) { return eFSNotMounted; }}else {return eFSNotMounted;}
#define CHECKOPENv		if( !m_bOpen ) { return ; }
#define BEGIN_LOCK_FS   TXRemovableFile::m_FSMutex[m_nDrive].Wait(MUTEX_INFO_CALL); if(m_bOpen ){
#define END_LOCK_FS     }TXRemovableFile::m_FSMutex[m_nDrive].Signal(MUTEX_INFO_CALL); CHECKOPEN
							
//FATFS s_FatFS;
DSTATUS s_DiskState = STA_NOINIT;
//Init this with unmounted state

/*###########################################################################*/
// disk functions
/*---------------------------------------------------------------------------*/
DSTATUS disk_initialize( BYTE nDrive )
{
	if (0==mmc_init())
		s_DiskState = RES_OK;
	else
		s_DiskState = STA_NOINIT;
	return s_DiskState;
} // disk_initialize()


/*---------------------------------------------------------------------------*/
DSTATUS disk_status( BYTE nDrive )
{ 
	return s_DiskState;
}

/*---------------------------------------------------------------------------*/
DRESULT disk_read( BYTE nDrive, BYTE* pDest, DWORD nSectNo, BYTE nSectCount )
{
	BYTE i;
	BYTE nRet;
	if( RES_OK != disk_status(nDrive )) { return RES_NOTRDY; }
	for (i=0;i<nSectCount;i++) {
		nRet = mmc_read_sector( nSectNo, pDest);
		if (0==nSectNo && RES_OK!= nRet) // retry to get boot sector
			nRet = mmc_read_sector( nSectNo, pDest );
		if( RES_OK != nRet )
			return RES_ERROR;
		nSectNo++;
	}
	return RES_OK;
} // disk_read()

/*---------------------------------------------------------------------------*/
DRESULT disk_write (BYTE nDrive, const BYTE* pSource, DWORD nSectNo, BYTE nSectCount )
{
	BYTE i;
	BYTE nRet;
	if( RES_OK != disk_status(nDrive )) { return RES_NOTRDY; }
	for (i=0;i<nSectCount;i++) {
		nRet = mmc_write_sector( nSectNo, (BYTE* )pSource);
		if( RES_OK != nRet )
			return RES_ERROR;
		nSectNo++;
	}
	return RES_OK;
}

/*---------------------------------------------------------------------------*/
void disk_timerproc (void)
{
}

/*---------------------------------------------------------------------------*/
DRESULT disk_ioctl (BYTE nDrive, BYTE nParam, void* pParam)
{
	DWORD dwRawSize;
	int nRet ;
	#if 0
	switch (nParam) {
		case GET_SECTOR_COUNT:
			nRet = TXRemovableFile::sm_pBlockDriver[nDrive]->Info(&dwRawSize,TXBlockDevice::paramRawSize);	
		
			dwRawSize/=TXRemovableFile::sm_DiskBlockSize[nDrive];
			*(DWORD*)pParam=dwRawSize ;
		
			if( eOK != nRet ) 
				return RES_ERROR;
			return RES_OK;
		case SET_SECTOR_SIZE:
			assertnr(TXAssertions,eNullPointer,RES_ERROR,NULL!=pParam);
			dwRawSize= *(WORD*)pParam;
			TXRemovableFile::sm_DiskBlockSize[nDrive]=dwRawSize;
			TXRemovableFile::sm_pBlockDriver[nDrive]->SetBlockLength(nDrive,dwRawSize);
			return RES_OK;
		default:
			return RES_ERROR;
	}
	#endif
	return RES_OK;
}

#if 0
/*---------------------------------------------------------------------------*/
extern "C" {
	void RTC_GetDate(BYTE aDate[3]) ;
	void RTC_GetTime(BYTE aTime[3]) ;
};

DWORD get_fattime (void)
{
	DWORD dwRet;
	BYTE aTime[3];
	BYTE aDate[3];
	RTC_GetTime(aTime);
	RTC_GetDate(aDate);
	dwRet  = ((aTime[2] / 2) & 0x1F);
	dwRet |= ((DWORD)aTime[1]  & 0x3F) << 5;
	dwRet |= ((DWORD)aTime[0] & 0x1F) << 11;
	dwRet |= ((DWORD)aDate[0] & 0x1F) << 16;
	dwRet |= ((DWORD)aDate[1]  & 0x0F) << 21;
	dwRet |= (((DWORD)aDate[2] + 20) & 0x7F) << 25;
	return dwRet;
} // get_fattime()

#endif
